#include <stdio.h>
#ifndef MATRICI_H
#define MATRICI_H
#include <iostream>
#include <fstream>
#include <cmath>
#include <stdarg.h>
#include <float.h>
using namespace std;
class Matrice {
protected:
       double ** _el;
       int n,m; 
public:      
      Matrice ():_el(0) {};
      Matrice (int N,int M,double v=DBL_MAX, ...):n(N+2),m(M+2)  {

              int id=0;
              va_list ap;
              double dval;
              _el=new double*[n];
              va_start(ap,v);
              if (v==DBL_MAX) {
                  for (int k=0; k<n; k++) {
                      _el[k]=new double [m];
                      for (int h=0; h<m; h++) _el[k][h]=0.;
                  };
              } else {
                  for (int k=0; k<n; k++) {
                      _el[k]=new double [m];
                      if (k==0) continue;
                      for (int h=1; h<m; h++) {
                          if (id++==0) dval=v;
                          else dval=va_arg(ap,double);
                          _el[k][h]=dval;
                      }
                  };
              }
              va_end(ap);
              
              
              
      };
/*      Matrice (int N, int M):n(N),m(M) {
              _el=new double*[n];
              for (int k=0; k<n; k++) {
                  _el[k]=new double [m];
                  for (int h=0; h<m; h++) _el[k][h]=0.;
              };
      }; */
      Matrice (const Matrice & A) {
              n=A.n;
              m=A.m;
              _el=new double*[n];
              for (int k=0; k<n; k++) _el[k]=new double [m];              
              for (int i=0;i<n;i++) {
                  for (int j=0; j<m; j++) {
                    _el[i][j]=A._el[i][j];    
                  }    
              }
      };
      void operator= (const Matrice & A) {
              if (n!= A.n || m!=A.m) {
//                 printf("richiesto di uguagliare MATRICI non compatibili \n");
//                 return ;        
              }
              if (_el!=0) {
                  for (int k=0; k<n; k++) delete [] _el[k];
                  delete [] _el;
                  _el=0;              
              }
              n=A.n;
              m=A.m;              
              _el=new double*[n];
              for (int k=0; k<n; k++) _el[k]=new double [m];              
              for (int i=0;i<n;i++) {
                  for (int j=0; j<m; j++) {
                    _el[i][j]=A._el[i][j];    
                  }    
              }
      };
      virtual void operator= (const double * a) {
              for (int i=1;i<n-1;i++) {
                  for (int j=1; j<m-1; j++) {
                    _el[i][j]=a[i*m+j];    
                  }    
              }
      };
      virtual ~Matrice() {
                 for (int k=0; k<n; k++) delete [] _el[k];
                 delete [] _el;
      }
      virtual void Reset() {
               for (int i=0;i<n;i++) {
                  for (int j=0; j<m; j++) {
                    _el[i][j]=0.;    
                  }    
              }
             
      };
      virtual int M() const { return m-2;};
      virtual int N() const { return n-2;};
//      virtual double* operator[](int i) { return _el[i]; };
      virtual double& operator()(int i, int j) { return _el[i][j]; };
      virtual double operator()(int i, int j) const{ return _el[i][j]; };
      virtual void Print(const char * mess) {
          printf("%s\n",mess);
          for (int i=1;i<n-1; i++) {
            for (int j=1; j<m-1; j++) {
                printf ("(%d,%d)=%14g ",i,j,_el[i][j]);
            }
            printf ("\n");
          }  
      }

      friend Matrice  operator* (const Matrice & A, const Matrice & B) {
              if (A.m!=B.n) {
                 printf("Prodotto tra matrice con %d colonne e matrice con %d righe non possibile\n",A.m,B.n); 
                 Matrice E(1,1,0.);
                 return E;             
              }
              Matrice P(A.N(),A.M());
              for (int i=1; i<A.n-1; i++) {
                  for (int j=1;j<B.m-1;j++) {
                      
                      for (int k=1; k<A.m-1; k++) {
                          P(i,j)+=A(i,k)*B(k,j);
                      }    
                  }    
              }
              return P;
      };
      friend Matrice  operator* (double v, const Matrice & A) {
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=v*A(i,j);
                  
                  }    
              }
              return P;
      };
      friend Matrice  operator* ( const Matrice & A,double v) {
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=v*A(i,j);
                  
                  }    
              }
              return P;
      };
      friend Matrice  operator/ ( const Matrice & A,double v) {
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=A(i,j)/v;
                  
                  }    
              }
              return P;
      };
      friend Matrice  operator+ ( const Matrice & A,double v) {
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=A(i,j)+v;
                  
                  }    
              }
              return P;
      };
      friend Matrice  operator+ ( double v,const Matrice & A) {
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=A(i,j)+v;
                  
                  }    
              }
              return P;
      };
      friend Matrice  operator+ (const Matrice & A, const Matrice & B) {
              if (A.m!=B.m || A.n != B.n) {
                 printf("Somma tra matrice con %d colonne e %d righe \n",A.m,A.n);
                 printf("con matrice con %d colonne e %d righe non possibile\n",B.m,B.n); 
                 Matrice E(1,1);
                 return E;             
              }
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=A(i,j)+B(i,j);
                          
                  }    
              }
              return P;
      };
      friend Matrice  operator- (const Matrice & A, const Matrice & B) {
              if (A.m!=B.m || A.n != B.n) {
                 printf("Sottrazione tra matrice con %d colonne e %d righe \n",A.m,A.n);
                 printf("con matrice con %d righe e %d colonne non possibile\n",B.m,B.n); 
                 Matrice E(1,1);
                 return E;             
              }
              Matrice P(A.N(),A.M());
              for (int i=0; i<A.n; i++) {
                  for (int j=0;j<A.m;j++) {
                      
                      P(i,j)=A(i,j)-B(i,j);
                          
                  }    
              }
              return P;
      };
              
};
class Colonna : public Matrice {
public:      
      Colonna():Matrice() {
              
      };
      Colonna(int N,double v=DBL_MAX, ...):Matrice(N,1) {
                  
              int id=0;
              va_list ap;
              double dval;
              va_start(ap,v);
              if (v==DBL_MAX) {
                  for (int k=0; k<n; k++) {
                      _el[k][0]=0.;
                  };
              } else {
                  for (int k=1; k<n-1; k++) {
                          if (id++==0) dval=v;
                          else dval=va_arg(ap,double);
                          _el[k][0]=dval;
                  };
              }
              va_end(ap);
                  
                  
      };
      Colonna(const Colonna & C):Matrice(C) {};
      Colonna(const Matrice & C):Matrice(C) {};
      void operator= (const Matrice & A) {
              if (N()!= A.N()) {
//                 printf("richiesto di uguagliare colonne non compatibili \n");
//                 return ;        
              }
              if (_el!=0) {
                  for (int k=0; k<n; k++) delete [] _el[k];
                  delete [] _el;
                  _el=0;              
              }
              n=A.N()+2;
              m=A.M()+2;              
              _el=new double*[n];
              for (int k=0; k<n; k++) _el[k]=new double [m];
              for (int i=0;i<n;i++) {
                  for (int j=0; j<m; j++) {
                    _el[i][j]=A(i,j);    
                  }    
              }
      };
//      virtual double operator[](int i) {return _el[0][i]; };
      virtual double& operator()(int j) { return _el[j][0]; };
      virtual double operator()(int j) const { return _el[j][0]; };
      virtual ~Colonna() {};
      virtual void Print(const char * mess) {
            printf("%s\n",mess);
            for (int j=1; j<n-1; j++) {
                printf ("(%d)=%14g \n",j,_el[j][0]);
            }
            printf ("\n");
      }
      virtual double Norma() {
              double sum=0.;
              for (int i=1; i<n-1;i++) sum+=_el[i][0]*_el[i][0];
              return sqrt(sum);       
      };
                  
};
class Riga : public Matrice {
public:      
      Riga():Matrice() {};
      Riga(int M,double v=DBL_MAX, ...):Matrice(1,M) {
              int id=0;
              va_list ap;
              double dval;
              va_start(ap,v);
              if (v==DBL_MAX) {
                  for (int k=0; k<m; k++) {
                      _el[0][k]=0.;
                  };
              } else {
                  for (int k=1; k<m-1; k++) {
                          if (id++==0) dval=v;
                          else dval=va_arg(ap,double);
                          _el[0][k]=dval;
                  };
              }
              va_end(ap);
               
               
      };
      Riga(const Riga & R):Matrice(R) {};
      Riga(const Matrice & R):Matrice(R) {};
      void operator= (const Matrice & A) {
              if (n!= A.N() || m!=A.M()) {
                 printf("richiesto di uguagliare matrici non compatibili \n");
                 return ;        
              }
              n=A.N();
              m=A.M();              
              for (int i=0;i<n;i++) {
                  for (int j=0; j<m; j++) {
                    _el[i][j]=A(i,j);    
                  }    
              }
      };
//      virtual double operator[](int i) {return _el[0][i]; };
      virtual double& operator()(int j) { return _el[0][j]; };
      virtual double operator()(int j) const { return _el[0][j]; };
      virtual ~Riga() {};
      virtual void Print(const char * mess) {
            printf("%s\n",mess);
            for (int j=1; j<m-1; j++) {
                printf ("(%d)=%14g ",j,_el[0][j]);
            }
            printf ("\n");
      }
      virtual double Norma() {
              double sum=0.;
              for (int j=1; j<m-1;j++) sum+=_el[0][j]*_el[0][j];
              return sqrt(sum);       
      };
                  
};
#endif
