#include "Utility.h"
#include <stdarg.h>
#include <float.h>
#include <cmath>

SimplePlot * W = SimplePlot::get();
void Draw( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,int a,int b,COLORS C, GrOpt O){

/*   
    inizializza grafica   
    Occorre inserire il range in A e B all'interno del quale
    varieranno le due grandezze (A_min,A_max,B_min,B_max)
    Per far questo cerco il minimo e il massimo delle due grandezze 
    e li aumento del 5% 
*/
//    std::cout<<"DRAW "<<W<<std::endl;
    if (O!=SAME) {
        double a_min,a_max,b_min,b_max;
        if (a!=0) {
            MinMax(alg,F,P,x,a_min,a_max,a);
        } else {
            a_min=F.xmin();
            a_max=F.xmax();
        }       
        if (b!=0) {
            MinMax(alg,F,P,x,b_min,b_max,b);
        } else {
            b_min=F.xmin();
            b_max=F.xmax();
        }       
    
        a_min-=(a_max-a_min)*0.05;
        a_max+=(a_max-a_min)*0.05;
        b_min-=(b_max-b_min)*0.05;
        b_max+=(b_max-b_min)*0.05;
	W->SetWindow(a_min,a_max,b_min,b_max);
    }
    W->AddImage(C);

   do {
           if (a==0) W->plot(x,P(b));
           else if (b==0) W->plot(P(a),x);
           else W->plot(P(a),P(b));
           alg(F,P,x);

   } while (x<F.xmax());
   
   
} 
/* void PoincareDraw( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,int a,int b,double p,COLORS C, GrOpt O){
  
//     inizializza grafica   
//     Occorre inserire il range in A e B all'interno del quale
//     varieranno le due grandezze (A_min,A_max,B_min,B_max)
//     Per far questo cerco il minimo e il massimo delle due grandezze 
//     e li aumento del 5% 

    extern double step;
    if (O!=SAME) {
        double a_min,a_max,b_min,b_max;
        if (a!=0) {
            MinMax(alg,F,P,x,a_min,a_max,a);
        } else {
            a_min=F.xmin();
            a_max=F.xmax();
        }       
        if (b!=0) {
            MinMax(alg,F,P,x,b_min,b_max,b);
        } else {
            b_min=F.xmin();
            b_max=F.xmax();
        }       
    
        a_min-=(a_max-a_min)*0.05;
        a_max+=(a_max-a_min)*0.05;
        b_min-=(b_max-b_min)*0.05;
        b_max+=(b_max-b_min)*0.05;
	W.SetWindow(a_min,a_max,b_min,b_max);
	W.AddImage(C);
    }

    double xr=0.25;
   do {
           if (fabs(x/p-int(x/p))<step/4){
 //              printf("%g %g %g\n",x,x/p,P(2));
  
                   if (a==0) drawfillellipse(x,P(b),xr,xr/5);
                   else if (b==0) drawfillellipse(P(a),x,xr,xr/5);
                   else drawfillellipse(P(a),P(b),xr,xr/5);

              
                
           }
           alg(F,P,x);
           

   } while (x<F.xmax());
   
   
}  
  */
void Draw( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,
           double (*fx)(Colonna & P, double & x),double (*fy)(Colonna & P, double & x),
           COLORS C, GrOpt O){
/*   
    inizializza grafica   
    Occorre inserire il range in A e B all'interno del quale
    varieranno le due grandezze (A_min,A_max,B_min,B_max)
    Per far questo cerco il minimo e il massimo delle due grandezze 
    e li aumento del 5% 
*/
    if (O!=SAME) {
        double a_min,a_max,b_min,b_max;
        MinMax(alg,F,P,x,a_min,a_max,fx);
        MinMax(alg,F,P,x,b_min,b_max,fy);    
        a_min-=(a_max-a_min)*0.05;
        a_max+=(a_max-a_min)*0.05;
        b_min-=(b_max-b_min)*0.05;
        b_max+=(b_max-b_min)*0.05;
	W->SetWindow(a_min,a_max,b_min,b_max);
    }
    W->AddImage(C);

   do {
           W->plot(fx(P,x),fy(P,x));
           alg(F,P,x);

   } while (x<F.xmax());
   
   
}  
void Draw( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,
           double (*fy)(Colonna & P, double & x),
           COLORS C, GrOpt O){
/*   
    inizializza grafica   
    Occorre inserire il range in A e B all'interno del quale
    varieranno le due grandezze (A_min,A_max,B_min,B_max)
    Per far questo cerco il minimo e il massimo delle due grandezze 
    e li aumento del 5% 
*/
    if (O!=SAME) {
        double a_min,a_max,b_min,b_max;
	a_min=F.xmin();
	a_max=F.xmax();
        MinMax(alg,F,P,x,b_min,b_max,fy);    
        a_min-=(a_max-a_min)*0.05;
        a_max+=(a_max-a_min)*0.05;
        b_min-=(b_max-b_min)*0.05;
        b_max+=(b_max-b_min)*0.05;
	W->SetWindow(a_min,a_max,b_min,b_max);
    }
    W->AddImage(C);

   do {
           W->plot(x,fy(P,x));
           alg(F,P,x);

   } while (x<F.xmax());
   
   
}  
void Draw( double (*fy)(double  x),double a, double b,
           COLORS C, GrOpt O){
     extern double step;

    if (O!=SAME) {
        double a_min,a_max,b_min,b_max;
	a_min=a;
	a_max=b;
        MinMax(fy,a,b,b_min,b_max);    
        a_min-=(a_max-a_min)*0.05;
        a_max+=(a_max-a_min)*0.05;
        b_min-=(b_max-b_min)*0.05;
        b_max+=(b_max-b_min)*0.05;
	W->SetWindow(a_min,a_max,b_min,b_max);
    }
     W->AddImage(C);
     double lx=W->Xmin();
     do {
             
             W->plot(lx,fy(lx));
             lx+=step;

     } while (lx<W->Xmax());
   
   
}  





void Calcola( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
              const FuncColonna & F, Colonna  P, double x){
     

   do {
           alg(F,P,x);

   } while (x<F.xmax());
}
void MinMax( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,double &min,double &max,int a){
    min=DBL_MAX;
    max=-DBL_MAX;

   do {
           
           alg(F,P,x);
           if (min>P(a))min=P(a);
           if (max<P(a))max=P(a);

   } while (x<F.xmax());
      
}  
void MinMax( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,double &min,double &max,
           double (*fx)(Colonna & P, double & x)){
    min=DBL_MAX;
    max=-DBL_MAX;
   double f;
   do {
           
           alg(F,P,x);
           f=fx(P,x);
           if (min>f)min=f;
           if (max<f)max=f;

   } while (x<F.xmax());
      
} 
void MinMax(double (*fx)(double x),double a, double b, double &min,double &max){
     extern double step;
    min=DBL_MAX;
    max=-DBL_MAX;
   double f;
     double lx=a;
     do {
           f=fx(lx);
           if (min>f)min=f;
           if (max<f)max=f;
	   lx+=step;
	   

   } while (lx<b);
      
} 
double  Calcola( void (*alg) (const FuncColonna & F, Colonna & P, double & x),
           const FuncColonna & F, Colonna  P, double  x,int a,double tar,int b){

   double xold=0;
   if (a==0) xold=x;
   else xold=P(a);
   double yold=0;
   if (b==0) yold=x;
   else yold=P(b);
   double xc,yc,v=0;
   if (tar<=xold) {
      std::cout<<"ehi stai cercanod un valore fuori range!"<<std::endl;
      return yold; 
   }
   do {
	   alg(F,P,x);
	   
	   
           if (a==0) xc=x;
	   else xc=P(a);
	   if (b==0) yc=x;
	   else yc=P(b);
	   if (xc==tar) return yc;
	   if (xc>tar) {
	        v=yold+(yc-yold)/(xc-xold)*(tar-xold);
		return v; 
	   }
	  
            
   } while (x<F.xmax());
   
   return v;
} 
