#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include "GrWindow.h"
#include "Risolvi.h"
#include "Simula.h"
#include "Utility.h"
#define PI 3.1415
/* distribuzione gaussiana */
double sigma=1.0;
double media =0.;
double gauss(double x) {
   extern double sigma;
   extern double media;
   return 1./(sqrt(2.*PI)*sigma)*exp(-1.*(x-media)*(x-media)/(2.*sigma*sigma));
}


int main()
{
// ipotizzo di ripetere 100 esperimenti identici
  int N=100;
  double valO[N];
  double valL[N];
  double valS[N];
/* 
  Definisco il valore e la precisione con cui determino lo spazio percorso  
*/  
  extern double sigma;
  extern double media;
/****************************************
 Chiamo l'algoritmo per  l'estrazione 
 dei numeri casuali
 gli argomenti sono:
      1) oggetto funzione a una dimensione
      2) numero di punti da estrarre (intero)
      3) vettore in cui saranno salvati 
      i valori estratti. Di dimensioni >= al 
      numero di valori da estrarre!!! (double)
****************************************/
// simulo misure posizione oggetto
     media=0.;  // 0 mm
     sigma =0.3; // 0.3 mm di errore statistico 
     Function1D Gauss1(gauss,-5,5.);
     Reiezione(Gauss1,N,valO);
// simulo misure posizione Lente
     media=500.;  // 500 mm
     sigma =0.3; // 0.3 mm di errore statistico 
     Function1D Gauss2(gauss,490,510.);
     Reiezione(Gauss2,N,valL);
// simulo misure posizione Schermo
     media=625.;  // 625 mm
     sigma =2; // 2 mm di errore statistico 
     Function1D Gauss3(gauss,610.,640.);
     Reiezione(Gauss3,N,valS);
     
/***************************************
 definisco un istogramma in cui mettere i risultati del mio esperimento 
****************************************/
/* 
   definisco OGGETTO istogramma grafico 
   argomenti:
   1) titolo
   2) numero bin
   3) x minimo
   4) x massimo
*/
    GrIstogramma isto1("fuoco",40,80,120);
//  Ora simulo N esperimenti uguali
//         
    for (int k=0; k<N; k++) {
// calcolo per ogni esperimento i valori  misurati di u e v
// e di conseguenza mi determino F
       double Po,Pl,Ps,u,v,F;
       Po=valO[k];
       Pl=valL[k];
       Ps=valS[k];
       u=Pl-Po;
       v=Ps-Pl;
// Calcolo F=u*v/(u+v);
       F=u*v/(u+v);
// riempio istogramma
       isto1.Fill(F);
    }
   
    
    
/*  colore dell'istogramma */
    isto1.SetColor(RED);
/* disegno istogramma */

    isto1.Draw();  
    
/* stampo media e sigma dell'istogramma */    
    printf("media=%g , sigma=%g\n",isto1.media(),isto1.sigma());

   JobEnd();
   return 0;
}


