#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include "GrWindow.h"
#include "Risolvi.h"
#include "Simula.h"
#include "Utility.h"
#define PI 3.1415
/* distribuzione gaussiana */
double sigma=1.0;
double media =0.;
double gauss(double x) {
   extern double sigma;
   extern double media;
   return 1./(sqrt(2.*PI)*sigma)*exp(-1.*(x-media)*(x-media)/(2.*sigma*sigma));
}


// pendolo 
//   dv/dt=g
//   ds/dt=v
//   P           F
//     
//   1   v         dv/dt   =f1(P,t)
//   2   s         ds/dt   =f2(P,t)
//
double f1(Colonna P, double t ) {
     return 9.8;
};
double f2(Colonna P, double t ) {
     return P(1);
};
double step;
int main()
{
/* inizializzo il generatore */
     srand(567456);
// ipotizzo di ripetere 100 esperimenti identici
  int N=1000;
  double valS[N];
/* 
  Definisco il valore e la precisione con cui determino lo spazio percorso  
*/  
  extern double sigma;
  extern double media;
  media=1.;  // 1 m
  sigma =0.01; // 1 cm di errore statistico 
  Function1D Gauss(gauss,-0.,2.);
/****************************************
 Chiamo l'algoritmo per  l'estrazione 
 dei numeri casuali
 gli argomenti sono:
      1) oggetto funzione a una dimensione
      2) numero di punti da estrarre (intero)
      3) vettore in cui saranno salvati 
      i valori estratti. Di dimensioni >= al 
      numero di valori da estrarre!!! (double)
****************************************/
     Reiezione(Gauss,N,valS);
     
// Step da usare in soluzione equa. diff.    
    extern double step;
    step=0.0005;
// Definisco vettore di funzioni 2 componenti e range in X
//   P           F
//     
//   1   w         dw/dt       f1(P,t)
//   2   phi       dphi/dt     f2(P,t)
//
    FuncColonna F(2,0.,10.);
 // addiziona componenti  con F.add(....)
    F.add(f1);
    F.add(f2);
     
     
// Condizioni iniziali        
//   P 
//     
//   1   v
//   2   s
//
    Colonna P(2);
    P(1)=0.;
    P(2)=0.;


    double t=0;
/***************************************
 definisco un istogramma in cui mettere i risultati del mio esperimento 
****************************************/
/* 
   definisco OGGETTO istogramma grafico 
   argomenti:
   1) titolo
   2) numero bin
   3) x minimo
   4) x massimo
*/
    GrIstogramma isto1("gravita",40,9.0,10.5);
//  Ora simulo N esperimenti uguali
//         
    for (int k=0; k<N; k++) {
// per ogni esperimento suppongo di determinare t quando l'oggetto ha
// percorso uno spazio pari ad S con S affetto da errore statistico sigma
       double S=valS[k];
// Calcola (alg,F,P,t,id1,value,id2)
// alg  == algoritmo di risuluzione equ. diff.
// F == vettore funzione 
// P== Vettore condizioni iniziali variabili dipendenti
// t == variabile indipendente con sua cond. iniziale.
// id1 == indice identificante la grandezza da usare per interrompere calcolo
// value == valore della grandezza da usare per interrompere calcolo
// id2 == indice identificante la grandezza della quale si vuole il valore 
//   0   t 
//   P  
//   1   v
//   2   s
       double T;
       T= Calcola(RungeKutta4,F,P,t,2,S,0);
// introduco un'incertezza nella misura di T
       media=T;     // 
       sigma =0.01*T; // precisione relativa
// ampiezza +/- 10 %       
       Function1D Gauss2(gauss,T-0.1*T,T+0.1*T);
//estraggo 1 valore
       double Tv[1];
       Reiezione(Gauss2,1,Tv);
       
// Calcolo g = 2S/(T*T)
// S misurato (1 m) mentre l'errore e' nel valore vero
// T e' il valore vero dato S vero usato nel calcolo analitico
// per cui introduco l'incertezza della misura con Tv
       
       double G;
       G=2.*1./(Tv[0]*Tv[0]);    
       isto1.Fill(G);
    }
   
    
    
/*  colore dell'istogramma */
    isto1.SetColor(RED);
/* disegno istogramma */

    isto1.Draw();  
    
/* stampo media e sigma dell'istogramma */    
    printf("media=%g , sigma=%g\n",isto1.media(),isto1.sigma());

   JobEnd();
   return 0;
}


